package es.verdnatura.domain

import android.content.Context
import es.verdnatura.presentation.view.feature.login.model.*
import retrofit2.Call

class GetLoginUserCase(context: Context) : RestClient(context)
{

    fun login(usuario: String, password: String, androiid: String): Call<String>
    {
        val params: ArrayList<String> = ArrayList()
        params.add(usuario)
        params.add(password)
        params.add(androiid)
        return restClient!!.login("json", "1", usuario, password, "application/json", params)
    }

    fun device_checkLogin(
        usuario: String,
        password: String,
        android_id: String
                         ): Call<LoginDevice>
    {
        val params: ArrayList<String> = ArrayList()
        params.add(usuario)
        params.add(android_id)
        return restClient!!.device_checkLogin(
            "json",
            "1",
            usuario,
            password,
            "application/json",
            params
                                             )
    }

    fun worker_getId(usuario: String, password: String): Call<String>
    {
        val params: ArrayList<String> = ArrayList()
        return restClient!!.worker_getId("json", "1", usuario, password, "application/json", params)
    }

    fun deviceLog_add(
        usuario: String,
        password: String,
        app: String,
        versionApp: String,
        android_id: String
                     ): Call<Void>
    {
        val params: ArrayList<String> = ArrayList()
        params.add(app)
        params.add(versionApp)
        params.add(android_id)
        return restClient!!.deviceLog_add(
            "json",
            "1",
            usuario,
            password,
            "application/json",
            params
                                         )
    }

    fun salixLogin(usuario: String, password: String): Call<LoginSalixVO>
    {
        return salixClient!!.login("application/json", LoginSalixVO(usuario, password))
    }
    //NODEJS TEST

    fun nodeJsTest(
        smarttag: String,
        wagon: String,
        shelving: String
                  ): Call<NodeJsService.SmartTagNode>
    {
        return nodejsClient!!.bindShelving("application/json", "A0A3B8224DBF", "ABC", "2")
        // return nodejsClient!!.bindShelving("application/json", NodeJsService.SmartTagNode(smarttag, wagon, shelving),"A0A3B8224DBF","ABC","2")

    }

    /*   fun checkVersion_old(usuario: String, password: String, version: String): Call<Boolean>
      {
          val params: ArrayList<String> = ArrayList()
          params.add(version)
          return restClient!!.version("json", "1", usuario, password, "application/json", params)

      //SALIX MENSAJE :SERGIO: PARA NO ENVIAR MENSAJES A COMERCIALES PONGO QUE LAS MODIFICACIONES SE ENVIAN AL CANAL CREADO.
*/
       fun sendChekingPresence(token:String,workerId:Int,message:String) : Call<Boolean>{
              return salixClient!!.sendChekingPresence(content_type = "application/json", authorization = token, params = SalixMessageVO(workerId = workerId,message = message))
          }

    // SERGIO: PARA DESARROLLO Y PRUEBAS SE DESCOMENTA ESTAS LÍNEAS Y SE COMENTAN LAS DE ARRIBA

       /*  fun sendChekingPresence(token: String, workerId: Int, message: String): Call<Boolean>
       {
          return salixClient!!.sendGroup(
              content_type = "application/json",
              authorization = token,
              params = SalixGrupo(to = "#android-test", message = message)
                                        )
      }*/

fun checkVersion(usuario: String, password: String, nameApp: String): Call<versionApp>
{
val params: ArrayList<String> = ArrayList()
params.add(nameApp)
return restClient!!.getVersion("json", "1", usuario, password, "application/json", params)
}

}