package es.verdnatura.domain

import android.content.Context
import es.verdnatura.presentation.view.feature.presacador.model.PreSacadorItemVO
import retrofit2.Call

class GetPreSacadorUseCase(context: Context) : RestClient(context) {

    fun ticketToPrePrepare(
        usuario: String,
        password: String,
        ticketFk: String,
        sectorFk: String
    ): Call<List<PreSacadorItemVO>> {
        val params: ArrayList<String> = ArrayList()
        params.add(ticketFk)
        params.add(sectorFk)
        return restClient!!.ticketToPrePrepare(
            "json",
            "1",
            usuario,
            password,
            "application/json",
            params
        )
    }

    fun itemPlacementSupplyGetOrder(
        usuario: String,
        password: String,
        sectorFk: String
    ): Call<List<PreSacadorItemVO>> {
        val params: ArrayList<String> = ArrayList()
        params.add(sectorFk)
        return restClient!!.itemPlacementSupplyGetOrder(
            "json",
            "1",
            usuario,
            password,
            "application/json",
            params
        )
    }

    fun itemPlacementSupplyCloseOrder(
        usuario: String,
        password: String,
        id: String,
        quantity: String
    ): Call<String> {
        val params: ArrayList<String> = ArrayList()
        params.add(id)
        params.add(quantity)
        return restClient!!.itemPlacementSupplyCloseOrder(
            "json",
            "1",
            usuario,
            password,
            "application/json",
            params
        )
    }

}