package es.verdnatura.domain

import es.verdnatura.presentation.view.feature.login.model.LoginSalixVO
import es.verdnatura.presentation.view.feature.login.model.SalixGrupo
import es.verdnatura.presentation.view.feature.login.model.SalixMessageVO
import retrofit2.Call
import retrofit2.http.Body
import retrofit2.http.Header
import retrofit2.http.POST

interface SalixService {

    @POST("Accounts/login")
    fun login(@Header("Content-Type") content_type: String,
              @Body params: LoginSalixVO):
            Call<LoginSalixVO>

    @POST("chats/sendCheckingPresence")
    fun sendChekingPresence(
        @Header("Content-Type") content_type: String,
        @Header("Authorization") authorization: String,
        @Body params: SalixMessageVO):
            Call<Boolean>

    @POST("chats/send")
    fun sendGroup(
        @Header("Content-Type") content_type: String,
        @Header("Authorization") authorization: String,
        @Body params: SalixGrupo
    ):
            Call<Boolean>


}