package es.verdnatura.presentation.base

import androidx.lifecycle.LifecycleObserver
import androidx.lifecycle.ViewModel
import org.json.JSONObject

abstract class BaseViewModel : ViewModel(), LifecycleObserver



fun nameofFunction(function: Any): String
{

    // return Thread.currentThread().stackTrace[1].methodName

    return function.javaClass.enclosingMethod!!.name
}

fun getMessageFromResponse(ResponseMessage: String): String
{
    return try
    {
        val answerError = JSONObject(ResponseMessage)
        answerError.get("Message").toString()
    } catch (e: Exception)
    {
        ResponseMessage
    }
}

fun getMessageError(callFunction: String): String
{

    return when (callFunction)
    {
        "collection_getTickets" -> "No hay tickets para sacar. Llamada $callFunction."
        "collection_new_wagon" -> "No hay tickets para sacar. Llamada $callFunction."
        else ->
        {
            "Error en la llamada $callFunction."
        }
    }

}

fun getMessageFromAllResponse(callFunction: String, ResponseMessage: String): String
{

    var messageFromError: String
    var returnMessage: String

    try
    {
        val answerError = JSONObject(ResponseMessage)
        messageFromError = answerError.get("Message").toString()
    } catch (e: Exception)
    {
        messageFromError = ResponseMessage
    }

    // if (messageFromError.isEmpty()) {

    //sergio:para personalizar los mensajes de respuesta según la llamada.
    when (callFunction)
    {
        "collection_getTickets" -> returnMessage ="No hay tickets para sacar. Llamada $callFunction."
        else ->
        {
            returnMessage = "Llamada $callFunction."
        }
    }
    //}
    return "$messageFromError.$returnMessage"

}