package es.verdnatura.presentation.view.component

import android.app.Dialog
import android.app.TimePickerDialog
import android.content.Context
import android.view.View
import com.google.android.material.textfield.TextInputEditText
import es.verdnatura.R
import kotlinx.android.synthetic.main.component_custom_hour.*
import java.text.SimpleDateFormat
import java.util.*


class  CustomDialogHour(context: Context) : Dialog(context, R.style.DialogTheme) {

    init {
        setContentView(R.layout.component_custom_hour)
    }

    fun getDestinoEditText(): TextInputEditText {
        return custom_dialog_destino_value
    }

    fun getDestinoValue(): String {
        return custom_dialog_destino_value.text.toString()
    }

    fun setDestinoValue(value: String): CustomDialogHour {
        custom_dialog_destino_value.setText(value)
        custom_dialog_destino_value.visibility = View.VISIBLE
        return this
    }


    fun getHoraEditText(): TextInputEditText {
        return custom_dialog_hour_value
    }

    fun getHoraValue(): String {
        return custom_dialog_hour_value.text.toString()
    }

    fun setHoraValue(value: String): CustomDialogHour {
        custom_dialog_hour_value.setText(value)
        custom_dialog_hour_value.visibility = View.VISIBLE
        ib_obtener_hora.setOnClickListener {
            val cal = Calendar.getInstance()
            val timeSetListener = TimePickerDialog.OnTimeSetListener { timePicker, hour, minute ->
                cal.set(Calendar.HOUR_OF_DAY, hour)
                cal.set(Calendar.MINUTE, minute)
                custom_dialog_hour_value.setText(SimpleDateFormat("HH:mm").format(cal.time))
            }
            TimePickerDialog(context, timeSetListener, cal.get(Calendar.HOUR_OF_DAY), cal.get(Calendar.MINUTE), true).show()
        }
        return this
    }

    fun setTitle(title: String): CustomDialogHour {
        custom_dialog_title.visibility = View.VISIBLE
        custom_dialog_title.text = title
        return this
    }

    fun setDescription(description: String): CustomDialogHour {
        custom_dialog_description.visibility = View.VISIBLE
        custom_dialog_description.text = description
        return this
    }

    fun setOkButton(text: String, onButtonClicked: () -> Unit): CustomDialogHour {
        custom_dialog_button_ok.visibility = View.VISIBLE
        custom_dialog_button_ok.text = text
        custom_dialog_button_ok.setOnClickListener { onButtonClicked() }
        return this
    }

    fun setKoButton(text: String, onButtonClicked: () -> Unit): CustomDialogHour {
        custom_dialog_button_ko.visibility = View.VISIBLE
        custom_dialog_button_ko.text = text
        custom_dialog_button_ko.setOnClickListener { onButtonClicked() }
        return this
    }

}