package es.verdnatura.presentation.view.component

import android.app.Dialog
import android.content.Context
import android.view.View
import androidx.recyclerview.widget.RecyclerView
import com.google.android.material.textfield.TextInputEditText
import es.verdnatura.R
import kotlinx.android.synthetic.main.component_custom_list_dialog.*


class CustomDialogList (context: Context) : Dialog(context, R.style.DialogTheme) {

    init {
        setContentView(R.layout.component_custom_list_dialog)
    }

    fun getRecyclerView() : RecyclerView {
        return item_recyclerview
    }

    fun getEditText() : TextInputEditText {
        return custom_dialog_value
    }

    fun getEditTextTwo() : TextInputEditText {
        return custom_dialog_value_two
    }

    fun getValue() : String {
        return custom_dialog_value.text.toString()
    }

    fun setValue(value : String): CustomDialogList{
        custom_dialog_value.setText(value)
        textinputlayout_username.visibility = View.VISIBLE
        return this
    }

    fun getValueTwo() : String {
        return custom_dialog_value_two.text.toString()
    }

    fun setValueTwo(value : String): CustomDialogList{
        custom_dialog_value_two.setText(value)
        textinputlayout_two.visibility = View.VISIBLE
        return this
    }

    fun setTitle(title: String): CustomDialogList {
        custom_dialog_title.visibility = View.VISIBLE
        custom_dialog_title.text = title
        return this
    }

    fun setDescription(title: String): CustomDialogList {
        custom_dialog_description.visibility = View.VISIBLE
        custom_dialog_description.text = title
        return this
    }


    fun setOkButton(text: String, onButtonClicked: () -> Unit): CustomDialogList {
        custom_dialog_button_ok.visibility = View.VISIBLE
        custom_dialog_button_ok.text = text
        custom_dialog_button_ok.setOnClickListener { onButtonClicked() }
        return this
    }

    fun setKoButton(text: String, onButtonClicked: () -> Unit): CustomDialogList {
        custom_dialog_button_ko.visibility = View.VISIBLE
        custom_dialog_button_ko.text = text
        custom_dialog_button_ko.setOnClickListener { onButtonClicked() }
        return this
    }

    fun setHintValue(text:String): CustomDialogList{
        custom_dialog_value.hint = text
        return this
    }

    fun setHintValueTwo(text:String): CustomDialogList{
        custom_dialog_value_two.hint = text
        return this
    }

    fun setTextTwoGone():CustomDialogList{
        textinputlayout_two.visibility = View.GONE
        return this
    }

    fun hideDialog():CustomDialogList{
        custom_dialog_value.visibility = View.GONE
        return this
    }

}