package es.verdnatura.presentation.view.component

import android.app.Dialog
import android.content.Context
import android.view.View
import com.google.android.material.textfield.TextInputEditText
import es.verdnatura.R
import kotlinx.android.synthetic.main.component_custom_three_dialog.*
import kotlinx.android.synthetic.main.component_custom_two_dialog.custom_dialog_button_ko
import kotlinx.android.synthetic.main.component_custom_two_dialog.custom_dialog_button_ok
import kotlinx.android.synthetic.main.component_custom_two_dialog.custom_dialog_button_ok_two
import kotlinx.android.synthetic.main.component_custom_two_dialog.custom_dialog_description
import kotlinx.android.synthetic.main.component_custom_two_dialog.custom_dialog_title

class CustomDialogThreeButtons (context: Context) : Dialog(context, R.style.DialogTheme) {

    init {
        setContentView(R.layout.component_custom_three_dialog)
    }


    fun setTitle(title: String): CustomDialogThreeButtons {
        custom_dialog_title.visibility = View.VISIBLE
        custom_dialog_title.text = title
        return this
    }

    fun setDescription(description: String): CustomDialogThreeButtons {
        custom_dialog_description.visibility = View.VISIBLE
        custom_dialog_description.text = description
        return this
    }

    fun setOkButton(text: String, onButtonClicked: () -> Unit): CustomDialogThreeButtons {
        custom_dialog_button_ok.visibility = View.VISIBLE
        custom_dialog_button_ok.text = text
        custom_dialog_button_ok.setOnClickListener { onButtonClicked() }
        return this
    }


    fun getValue() : String {
        return custom_dialog_value.text.toString()
    }

    fun getEditText() : TextInputEditText {
        return custom_dialog_value
    }
    fun setValue(value : String): CustomDialogThreeButtons{
        custom_dialog_value.setText(value)
        textinputlayout.visibility = View.VISIBLE
        return this
    }

    fun setOkButtonTwo(text: String, onButtonClicked: () -> Unit): CustomDialogThreeButtons {
        custom_dialog_button_ok_two.visibility = View.VISIBLE
        custom_dialog_button_ok_two.text = text
        custom_dialog_button_ok_two.setOnClickListener { onButtonClicked() }
        return this
    }

    fun setOkButtonThree(text: String, onButtonClicked: () -> Unit): CustomDialogThreeButtons {
        custom_dialog_button_ok_three.visibility = View.VISIBLE
        custom_dialog_button_ok_three.text = text
        custom_dialog_button_ok_three.setOnClickListener { onButtonClicked() }
        return this
    }

    fun setOkButtonFour(text: String, onButtonClicked: () -> Unit): CustomDialogThreeButtons {
        custom_dialog_button_ok_four.visibility = View.VISIBLE
        custom_dialog_button_ok_four.text = text
        custom_dialog_button_ok_four.setOnClickListener { onButtonClicked() }
        return this
    }

    fun setOkButtonAdd(text: String, onButtonClicked: () -> Unit): CustomDialogThreeButtons {
        custom_dialog_button_add.visibility = View.VISIBLE
        custom_dialog_button_add.text = text
        custom_dialog_button_add.setOnClickListener { onButtonClicked() }
        return this
    }

    fun setKoButton(text: String, onButtonClicked: () -> Unit): CustomDialogThreeButtons {
        custom_dialog_button_ko.visibility = View.VISIBLE
        custom_dialog_button_ko.text = text
        custom_dialog_button_ko.setOnClickListener { onButtonClicked() }
        return this
    }

}