package es.verdnatura.presentation.view.feature.buffer.fragment

import android.content.Context
import android.util.Log
import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import es.verdnatura.domain.GetPaletizadoresUserCase
import es.verdnatura.presentation.base.BaseViewModel
import es.verdnatura.presentation.base.getMessageError
import es.verdnatura.presentation.base.getMessageFromAllResponse
import es.verdnatura.presentation.common.ResponseItemVO
import retrofit2.Call
import retrofit2.Callback
import retrofit2.Response

class BufferFragmentViewModel(context: Context) : BaseViewModel() {
    private val GetPaletizadoresUserCase: GetPaletizadoresUserCase =
        GetPaletizadoresUserCase(context)


    private val _itembuffertype by lazy { MutableLiveData<ResponseItemVO>() }
    val itembuffertype: LiveData<ResponseItemVO>
        get() = _itembuffertype


    private val _bufferresponse by lazy { MutableLiveData<Boolean>() }
    val bufferresponse: LiveData<Boolean>
        get() = _bufferresponse


    fun buffer_setTypeByName(user: String, password: String, vBufferFk: String, vType: String,callFunction:String){
        GetPaletizadoresUserCase.buffer_setTypeByName(user, password, vBufferFk, vType)
            .enqueue(object : Callback<Boolean> {
                override fun onFailure(call: Call<Boolean>, t: Throwable) {


                    _itembuffertype.value = ResponseItemVO(
                        isError = true,
                        errorMessage = getMessageFromAllResponse(callFunction,t.message!!))

                }

                override fun onResponse(call: Call<Boolean>, response: Response<Boolean>) {

                    if (response.body() != null && response.body() == true) {

                        _itembuffertype.value = ResponseItemVO(
                            isError = false,
                            errorMessage = ""
                        )

                    } else {
                        //_bufferresponse.value = false
                        _itembuffertype.value = ResponseItemVO(
                            isError = true,
                            errorMessage = getMessageFromAllResponse(callFunction,response.message()))

                    }

                }


            })
    }
}



