package es.verdnatura.presentation.view.feature.controlador.fragment

import android.content.Intent
import es.verdnatura.presentation.view.feature.qr.QrFragmentViewModel


import android.content.SharedPreferences
import android.net.Uri
import android.os.Bundle
import android.view.View
import android.view.inputmethod.EditorInfo
import android.webkit.WebChromeClient
import android.webkit.WebSettings
import android.webkit.WebView
import android.webkit.WebViewClient
import androidx.lifecycle.Observer
import es.verdnatura.R
import es.verdnatura.databinding.FragmentQrBinding
import es.verdnatura.domain.ConstAndValues
import es.verdnatura.presentation.base.BaseFragment
import es.verdnatura.presentation.view.component.CustomDialog
import es.verdnatura.presentation.view.feature.main.activity.MainActivity
import kotlinx.android.synthetic.main.fragment_controlador.*
import kotlinx.android.synthetic.main.toolbar.*
import kotlinx.android.synthetic.main.fragment_web.*


class WebFragment(
    var entryPoint: String = ""
) : BaseFragment<FragmentQrBinding, QrFragmentViewModel>(QrFragmentViewModel::class) {

    private var user = ""
    private var password = ""
    private var sectorFk = ""
    private var warehouseFk = ""
    private var goBack: Boolean = false
    override fun getLayoutId(): Int = R.layout.fragment_web
    private lateinit var customDialog: CustomDialog
    private var type = ""
    private var itemscaned = ""
    //private lateinit var webView: WebViewClient

    companion object {
        fun newInstance(entryPoint: String) = WebFragment(entryPoint)
    }

    override fun init() {

      //  splash_progress.visibility = View.GONE
        customDialog = CustomDialog(requireContext())
        setToolbar()
        //setEvents()
        setWeb()
        super.init()
    }

    private fun setWeb() {
       // webView = WebViewClient()


        webView.setWebChromeClient (WebChromeClient())
      //  webView.setWebViewClient (wvClient);
        webView.getSettings (). setJavaScriptEnabled (true)
       // sergio:deprecated
        //webView.getSettings (). setPluginState (WebSettings.PluginState.ON)
        val webSettings = webView.settings
        webSettings.javaScriptEnabled = true
        webSettings.domStorageEnabled = true
        webSettings.loadWithOverviewMode = true
        webSettings.useWideViewPort = true
        webSettings.builtInZoomControls = true
        webSettings.displayZoomControls = false
        webSettings.setSupportZoom(true)
        webSettings.defaultTextEncodingName = "utf-8"


        webView.loadUrl ("https://salix.verdnatura.es/#!/item/index")

        val openURL = Intent(Intent.ACTION_VIEW)
      //  openURL.data = Uri.parse("https://salix.verdnatura.es/#!/ticket/3271614/tracking/index")
        openURL.data = Uri.parse("https://salix.verdnatura.es/#!/item/index")
        startActivity(openURL)

        //webView.loadUrl("http://www.google.com")
        //webView.loadUrl("https://test-salix.verdnatura.es/#!/ticket/3271614/tracking/index")
       /* webView.loadUrl("https://test-salix.verdnatura.es/")
        webView.settings.javaScriptEnabled = true
        webView.settings.setSupportZoom(true)*/

    }

    private fun setToolbar() {

        toolbar_title.text = entryPoint
    }

    override fun onPause() {
        goBack = true
        super.onPause()
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
        user = prefs.getString(USER, "").toString()
        password = prefs.getString(PASSWORD, "").toString()
        sectorFk = prefs.getInt(SECTORFK, 1).toString()
        warehouseFk = prefs.getInt(WAREHOUSEFK, 1).toString()
        type = ConstAndValues.PRECHECKER
        super.onCreate(savedInstanceState)
    }

   /* private fun setEvents() {

        backButton.setOnClickListener {
            requireActivity().onBackPressed()
        }

        scan_input.requestFocus()
        scan_input.setOnEditorActionListener { v, actionId, event ->
            if (actionId == EditorInfo.IME_ACTION_SEARCH || actionId == EditorInfo.IME_ACTION_DONE || actionId == 0) {
                goBack = false;
                if (!scan_input.text.isNullOrEmpty()) {
                    splash_progress.visibility = View.VISIBLE
                    viewModel.qr_getCall(user, password, scan_input.text.toString())
                    itemscaned = scan_input.text.toString()
                }

            }
            scan_input.setText("")
            (activity as MainActivity).hideKeyboard(scan_input)
            return@setOnEditorActionListener true
        }
        false
    }*/


    override fun observeViewModel() {

        with(viewModel) {
            qrresponse.observe(viewLifecycleOwner, Observer {
                //splash_progress.visibility = View.GONE
                if (it.isError) {

                    // getMessageFromJSON(it.errorMessage)
                    customDialog.setTitle("Error").setDescription( it.errorMessage+  " "+itemscaned)
                        .setOkButton("Aceptar") {
                            customDialog.dismiss()
                        }.show()
                } else {

                    customDialog.setTitle("Mensaje")
                        .setDescription("Operación " + itemscaned + ". " + it.response)
                        .setOkButton("Aceptar") {
                            customDialog.dismiss()
                            backButton.performClick()
                        }.show()

                }

            })
        }

    }


}

