package es.verdnatura.presentation.view.feature.controlvehiculo.fragment

import android.content.SharedPreferences
import android.os.Bundle
import android.view.View.*
import androidx.lifecycle.Observer
import es.verdnatura.R
import es.verdnatura.databinding.FragmentVehiclecontrolBinding
import es.verdnatura.presentation.base.BaseFragment
import es.verdnatura.presentation.common.loadUrl
import es.verdnatura.presentation.view.component.CustomDialog
import kotlinx.android.synthetic.main.fragment_controlador.splash_progress
import kotlinx.android.synthetic.main.fragment_vehiclecontrol_user.*
import kotlinx.android.synthetic.main.toolbar.*

class ControlVehiculoUsuarioFragment(
    var vUserFK: String = ""
) : BaseFragment<FragmentVehiclecontrolBinding, ControlVehiculoViewModel>(
    ControlVehiculoViewModel::class
) {

    private var user = ""
    private var userFk = ""
    private var password = ""
    private var sectorFk = ""
    private var warehouseFk = ""
    private var token = ""
    private var goBack: Boolean = false
    private var android_id: String = ""
   // private var onCollectionSelectedListener: OnCollectionSelectedListener? = null
    override fun getLayoutId(): Int = R.layout.fragment_vehiclecontrol_user
    private lateinit var customDialog: CustomDialog

    companion object {
        fun newInstance(vUserFK: String) = ControlVehiculoUsuarioFragment(vUserFK)
    }

    override fun init() {
        toolbar_title.text = getString(R.string.vehiclecontroluser)

        customDialog = CustomDialog(requireContext())

        goBack = false

        splash_progress.visibility = GONE
        setEvents()
        setControlVehicleUser()
        //sergio:se queda pendiente de revisar con javi
        //  setDialog()

        super.init()
    }

    override fun onPause() {
        goBack = true
        super.onPause()
    }

    private fun setControlVehicleUser() {
        val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
        user = prefs.getString(USER, "").toString()
        password = prefs.getString(PASSWORD, "").toString()
        token = prefs.getString(TOKEN, "").toString()
        warehouseFk = prefs.getInt(WAREHOUSEFK, 1).toString()
        android_id = getANDROIDID()

        if (userFk.equals(vUserFK)) {

            splash_progress.visibility = VISIBLE
            viewModel.machine_getWorkerPlate(user, password,"machine_getWorkerPlate")
            viewModel.deviceProduction_getnameDevice(user, password, android_id,"deviceProduction_getnameDevice")
            viewModel.deviceProductionUser_getWorker(user, password, android_id,"deviceProductionUser_getWorker")

        } else {
            userFk = vUserFK

            user_information.visibility = INVISIBLE
            name_vehiclecontrol.visibility = INVISIBLE
            user_image.setOnClickListener({backButton.performClick()})

        }
        user_image.loadUrl("https://salix.verdnatura.es/api/Images/user/160x160/$userFk/download?access_token=$token")
        viewModel.machine_getWorkerPlate(user, password,"machine_getWorkerPlate")
        name_vehiclecontrol.text = user
        registered_vehiclecontrol.text = ""
        deviceName.text = ""
        assigned_devicename.text = ""

    }

    override fun onCreate(savedInstanceState: Bundle?) {
        val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
        user = prefs.getString(USER, "").toString()
        password = prefs.getString(PASSWORD, "").toString()
        sectorFk = prefs.getInt(SECTORFK, 1).toString()
        warehouseFk = prefs.getInt(WAREHOUSEFK, 1).toString()
        userFk = prefs.getString(USERFK, "0").toString()
        super.onCreate(savedInstanceState)
    }

    private fun setEvents() {

        backButton.setOnClickListener {
            requireActivity().onBackPressed()
        }


    }

private fun setDialog(){
    /*   user_image.setOnClickListener({backButton.performClick()})
       val builder = AlertDialog.Builder(requireContext())
       val inflater = layoutInflater
       val view: View = inflater.inflate(R.layout.item_worker_image, null)
       builder.setView(view)
       val imgView: ImageView = view.findViewById(R.id.workerimage) as ImageView
       imgView.loadUrl("https://salix.verdnatura.es/api/Images/user/160x160/$userFk/download?access_token=$token")

       val dialog = builder.create()
       dialog.show()

   */
    /*   val image = ImageView(requireContext())
       image.setImageResource(R.drawable.barcode_scan)

       image.loadUrl("https://salix.verdnatura.es/api/Images/user/160x160/$userFk/download?access_token=$token")

       val builderr: AlertDialog.Builder =
           AlertDialog.Builder(requireContext(),R.style.DialogTheme)
               .setMessage("Sacador:")
              .setPositiveButton("Cerrar") { dialogInterface: DialogInterface, i: Int ->
                   fun onClick(dialog: DialogInterface, which: Int) {
                       dialog.dismiss()
                   }
               }

               .setView(image)
       builderr.create().show()

   // image.setOnClickListener { builderr.dismiss() }*/

}

    override fun observeViewModel() {

        with(viewModel) {
            splash_progress.visibility = GONE


            responsemachine.observe(viewLifecycleOwner, Observer {
                splash_progress.visibility = GONE
                if (it.isError) {
                    customDialog.setTitle("Error").setDescription(it.errorMessage)
                        .setOkButton("Cerrar") {
                            customDialog.dismiss()
                        }.show()
                } else {
                    //sergio: se modifica el response = null. En casi todas las llamadas se utilizaba para ver si había error.
                    // Ahora ya no.

                    if (it.response == "false") {

                    } else {

                        //  Log.i("VERDNATURA::", "valor devuelto ${it.response}")

                        if (it.type.equals("getnameDevice")) {
                            deviceName.text = it.response
                        }
                        if (it.type.equals("getWorker")) {
                            assigned_devicename.text = it.response
                        }
                        if (it.type.equals("getWorkerPlate")) {
                            registered_vehiclecontrol.text = it.response
                        }
                    }

                }

            })

        }

    }
}
