package es.verdnatura.presentation.view.feature.historicoshelving.fragment

    import android.content.SharedPreferences
    import android.view.View
    import android.view.inputmethod.EditorInfo
    import androidx.lifecycle.Observer
    import androidx.recyclerview.widget.LinearLayoutManager
    import es.verdnatura.R
    import es.verdnatura.databinding.FragmentItemshelvinglogBinding
    import es.verdnatura.domain.notNull
    import es.verdnatura.domain.toast
    import es.verdnatura.presentation.base.BaseFragment
    import es.verdnatura.presentation.view.component.CustomDialog
    import es.verdnatura.presentation.view.component.CustomDialogList
    import es.verdnatura.presentation.view.feature.historicoshelving.adapter.ItemShelvingLogAdapter
    import es.verdnatura.presentation.view.feature.main.activity.MainActivity
    import kotlinx.android.synthetic.main.activity_main.*
    import kotlinx.android.synthetic.main.buyers_fragment.*
    import kotlinx.android.synthetic.main.fragment_historicovehiculo.*
    import kotlinx.android.synthetic.main.fragment_item_card.*
    import kotlinx.android.synthetic.main.fragment_item_card.edit_itemFk
    import kotlinx.android.synthetic.main.fragment_item_card.splash_progress
    import kotlinx.android.synthetic.main.fragment_itemexpeditionstate_card.*
    import kotlinx.android.synthetic.main.fragment_itemshelvingdayofsale.*
    import kotlinx.android.synthetic.main.fragment_itemshelvinglog.*
    import kotlinx.android.synthetic.main.fragment_parking.*
    import kotlinx.android.synthetic.main.toolbar.*

class itemShelvingLogFragment(
        var entryPoint: String = ""
                          // ) : BaseFragment<FragmentItemdayofsaleCardBinding, itemShelvingLogViewModel>(itemShelvingLogViewModel::class) {
    ) : BaseFragment<FragmentItemshelvinglogBinding, itemShelvingLogViewModel>(itemShelvingLogViewModel::class) {
        private lateinit var customDialogList: CustomDialogList
        private var user = ""
        private var password = ""
        private var warehouseFk = ""
        private var adapter: ItemShelvingLogAdapter? = null
        private var itemScan = ""

        companion object {
            fun newInstance(entryPoint: String) = itemShelvingLogFragment(entryPoint)
        }

        private lateinit var customDialog: CustomDialog

        override fun getLayoutId(): Int = R.layout.fragment_itemshelvinglog

        override fun init() {

            customDialog = CustomDialog(requireContext())
            customDialogList = CustomDialogList(requireContext())
            setEvents()
            setToolBar(getString(R.string.itemShelvingLog))
            super.init()

        }

        private fun setToolBar(title: String) {
            toolbar_title.text = title



        }

        private fun setEvents() {
            edit_itemFk.requestFocus()
            edit_itemFk.setOnEditorActionListener { v, actionId, event ->
                if (actionId == EditorInfo.IME_ACTION_SEARCH || actionId == EditorInfo.IME_ACTION_DONE || actionId == 0 || actionId == 5) {
                    if (!edit_itemFk.text.toString().isNullOrEmpty()) {
                        itemShelvingLog_get(edit_itemFk.text.toString())

                        itemScan = edit_itemFk.text.toString()
                    }
                    edit_itemFk.setText("")
                    (activity as MainActivity).hideKeyboard(edit_itemFk)
                    return@setOnEditorActionListener true
                }
                false
            }


            backButton.setOnClickListener {
                requireActivity().onBackPressed()
            }

        }




        private fun itemShelvingLog_get(vShelvingFK: String) {
            val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
            user = prefs.getString(USER, "").toString()
            password = prefs.getString(PASSWORD, "").toString()
            warehouseFk = prefs.getInt(WAREHOUSEFK, 1).toString()
            splash_progress.visibility = View.VISIBLE
            viewModel.itemShelvingLog_get(user, password,vShelvingFK,"itemShelvingLog_get")

        }


        override fun observeViewModel() {
            with(viewModel) {

                loadItemShelvingLogList.observe(viewLifecycleOwner, Observer{ event ->
                    event.getContentIfNotHandled().notNull {
                        splash_progress.visibility = View.GONE
                        adapter = ItemShelvingLogAdapter(it.list)
                        itemshelvinglog_recyclerview.adapter = adapter
                        itemshelvinglog_recyclerview.layoutManager = LinearLayoutManager(requireContext(), LinearLayoutManager.VERTICAL, false)
                        setToolBar(getString(R.string.itemShelvingLog)+":"+itemScan)

                        // navigateToToday(it)
                        if  (it.list.isEmpty()){
                            customDialog.setTitle("Sin resultados")
                                .setDescription("No se ha podido obtener datos de la etiqueta escaneada. ")
                                .setOkButton("Cerrar") {
                                    customDialog.dismiss()
                                }.show()
                        }else{

                            if (it.list.get(0).isError){
                                customDialog.setTitle("Error")
                                    .setDescription(it.list.get(0).errorMessage)
                                    .setOkButton("Cerrar") {
                                        customDialog.dismiss()
                                    }.show()
                            }
                        }

                    }
                })
                response.observe(viewLifecycleOwner, Observer {
                    if (it.isError){

                        splash_progress.visibility = View.GONE
                        customDialog.setTitle("Error").setDescription(it.errorMessage).setOkButton("Cerrar"){
                            customDialog.dismiss()
                        }.show()

                    }else{

                        it.response.toast(requireContext())
                        /* customDialog.setTitle("Información").setDescription(it.response).setOkButton("Cerrar") {
                             customDialog.dismiss()
                         }.show()*/

                    }


                })


            }
        }



    }
