package es.verdnatura.presentation.view.feature.historicovehiculo.fragment


import android.content.SharedPreferences
import android.util.Log
import android.view.View
import android.view.inputmethod.EditorInfo
import androidx.lifecycle.Observer
import androidx.recyclerview.widget.LinearLayoutManager
import es.verdnatura.R
import es.verdnatura.databinding.FragmentHistoricovehiculoBinding
import es.verdnatura.domain.notNull
import es.verdnatura.domain.toast
import es.verdnatura.presentation.base.BaseFragment
import es.verdnatura.presentation.view.component.CustomDialog
import es.verdnatura.presentation.view.component.CustomDialogInput
import es.verdnatura.presentation.view.feature.historicovehiculo.adapter.HistoricoVehiculoAdapter
import es.verdnatura.presentation.view.feature.historicovehiculo.model.ItemHistoricoVehiculoList
import es.verdnatura.presentation.view.feature.main.activity.MainActivity
import kotlinx.android.synthetic.main.activity_main.*
import kotlinx.android.synthetic.main.fragment_historicovehiculo.*
import kotlinx.android.synthetic.main.fragment_historicovehiculo.splash_progress
import kotlinx.android.synthetic.main.toolbar.*
import java.text.SimpleDateFormat
import java.util.*


class HistoricoVehiculoFragment (
    var numberPlate:String = ""
    ) : BaseFragment<FragmentHistoricovehiculoBinding, HistoricoVehiculoViewModel>(
        HistoricoVehiculoViewModel::class) {

        private var user = ""
        private var userFk = ""
        private var password = ""
        private var sectorFk = ""
        private var warehouseFk = ""
        private var adapter : HistoricoVehiculoAdapter? = null
        private lateinit var customDialogInput: CustomDialogInput
        private lateinit var customDialog: CustomDialog


        companion object {
            fun newInstance(entryPoint:String) = HistoricoVehiculoFragment(entryPoint)
        }

        override fun getLayoutId(): Int = R.layout.fragment_historicovehiculo


        override fun init()
        {
            val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER,0)
            user = prefs.getString(USER,"").toString()
            userFk=prefs.getString(USERFK,"").toString()
            password = prefs.getString(PASSWORD,"").toString()
            sectorFk = prefs.getInt(SECTORFK,1).toString()
            warehouseFk = prefs.getInt(WAREHOUSEFK,1).toString()
            customDialogInput = CustomDialogInput(requireContext())
            customDialog = CustomDialog(requireContext())
            requireActivity().main_bottom_navigation.visibility = View.GONE


            ////Log.i("VERDNATURA:","la matricula es $numberPlate")
            //sergio: revisar entrypoint
            viewModel.machineWorker_getHistorical(user,password,numberPlate,"machineWorker_getHistorical")
            toolbar_title.text = getString(R.string.vehiclediary)
            setEvents()
            super.init()
        }


        private fun setEvents(){
            backButton.setOnClickListener {
                requireActivity().onBackPressed()
             }
        }

        override fun observeViewModel() {
            with(viewModel){
                loadHistoricoVehiculoList.observe(viewLifecycleOwner, Observer{ event ->
                    event.getContentIfNotHandled().notNull {
                        splash_progress.visibility = View.GONE
                        adapter = HistoricoVehiculoAdapter(it.list)
                        historicovehiculo_recyclerview.adapter = adapter
                        historicovehiculo_recyclerview.layoutManager = LinearLayoutManager(requireContext(), LinearLayoutManager.VERTICAL, false)
                        navigateToToday(it)

                    }
                })
            }
        }

        private fun navigateToToday(it: ItemHistoricoVehiculoList){
            var positionToday = 0
            val sdf = SimpleDateFormat("yyyy-MM-dd")
            val currentDate = sdf.format(Date())

            for (item in it.list){
                if (currentDate == item.inTimed){
                    break
                }
                positionToday += 1
            }

            historicovehiculo_recyclerview.scrollToPosition(positionToday)
        }


}