package es.verdnatura.presentation.view.feature.login.fragment

import android.app.AlarmManager
import android.app.PendingIntent
import android.content.Context
import android.content.Intent
import android.content.SharedPreferences
import android.content.pm.PackageInfo
import android.content.pm.PackageManager
import android.net.Uri
//import android.preference.PreferenceManager
import androidx.preference.PreferenceManager
import android.view.KeyEvent
import android.view.View
import androidx.lifecycle.Observer
import android.provider.Settings
import android.util.Log
import es.verdnatura.R
import es.verdnatura.databinding.FragmentLoginBinding
import es.verdnatura.presentation.base.BaseFragment
import es.verdnatura.presentation.common.hideKeyboard
import es.verdnatura.presentation.view.component.CustomDialog
import es.verdnatura.presentation.view.feature.login.activity.LoginActivity
import es.verdnatura.presentation.view.feature.login.model.LoginDevice
import es.verdnatura.presentation.view.feature.login.model.LoginItemVO
import es.verdnatura.presentation.view.feature.login.model.workerId
import es.verdnatura.presentation.view.feature.main.activity.MainActivity
import kotlinx.android.synthetic.main.fragment_ajustes.*
import kotlinx.android.synthetic.main.fragment_login.*
import kotlinx.android.synthetic.main.fragment_login.splash_progress
import java.lang.Boolean.TRUE

class LoginFragment : BaseFragment<FragmentLoginBinding, LoginViewModel>(LoginViewModel::class) {

    private lateinit var customDialog: CustomDialog

    companion object {
        fun newInstance() = LoginFragment()
    }

    override fun getLayoutId(): Int = R.layout.fragment_login

    override fun init() {

        customDialog = CustomDialog(requireContext())
        saveIdentifiers()
        checkUser()
        button_login.setOnClickListener(View.OnClickListener {
            splash_progress.visibility = View.VISIBLE
            // Log.i(TD,"el imei pasado al login es ${getANDROIDID()}")
            /*    viewModel.login(
                   edittext_username.text.toString(),
                   edittext_password.text.toString(),
                   getANDROIDID()
               )*/

                viewModel.device_checkLogin(
                edittext_username.text.toString(),
                edittext_password.text.toString(),
                getANDROIDID(),callFunction = "device_checkLogin"
                 )

        })

        textview_remember_password.setOnClickListener {
            edittext_username.setText("")
            edittext_password.setText("")
            switch_remember.isChecked = false
            saveRemember(false)
        }



        edittext_server.setText(this.getDefaults("base_url", this.requireContext()))
        edittext_server.setOnKeyListener(View.OnKeyListener { v, keyCode, event ->
            if (keyCode == KeyEvent.KEYCODE_ENTER && event.action == KeyEvent.ACTION_UP) {
                this.setDefaults("base_url", edittext_server.text.toString(), this.requireContext())
                this.hideKeyboard()
//sergio: deberia lanzar la funcion nueva creada por mi restartapp de BaseFragment. Pero no vuelve a arrancar
                restartapp()
                return@OnKeyListener false

            }
            false
        })


        textview_welcome.setOnLongClickListener {
            edittext_server.isEnabled = TRUE
            true
        }

        //NODEJS TEST
      //  Log.i("VERDNATURA:","NODEJS in")
     //   viewModel.nodeJsTest("A0A3B8224DBF","ABC","1")

    }

    private fun saveIdentifiers() {

        val resolver = requireActivity().contentResolver

        val AndroidId: String = Settings.Secure.getString(resolver, Settings.Secure.ANDROID_ID)
        var deviceName = Settings.Secure.getString(resolver, "bluetooth_name")

        val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
        val editor = prefs.edit()
        editor.putString(ANDROID_ID, AndroidId)
        editor.putString(DEVICENAME, deviceName)
        editor.apply()

    }

    private fun checkUser() {
        val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
        if (prefs.getBoolean(RECORDAR, false)) {
            edittext_username.setText(prefs.getString(USER, ""))
            edittext_password.setText(prefs.getString(PASSWORD, ""))
            if (edittext_password.text.toString().isNotEmpty()) {
                switch_remember.isChecked = true
            }
        }

    }

    override fun observeViewModel() {
        with(viewModel) {

            versionappitem.observe(viewLifecycleOwner, Observer {
                splash_progress.visibility = View.INVISIBLE
                if (it.isError) {
                    customDialog.setTitle("Error").setDescription(it.errorMessage)
                        .setOkButton("Cerrar") {
                            customDialog.dismiss()
                        }.show()
                } else {
                    splash_progress.visibility = View.VISIBLE
                    if (it.version.equals(getInfoVersionNameApp())) {
                        splash_progress.visibility = View.INVISIBLE
                        goToMain()
                    } else {

                        customDialog.setTitle(getString(R.string.Actualizar))
                            .setDescription(getString(R.string.updatemng)).setOkButton(
                                getString(
                                    R.string.Actualizar
                                )
                            ) {
                                val openURL = Intent(Intent.ACTION_VIEW)
                                openURL.data =
                                    Uri.parse("https://app.verdnatura.es/bin/vn-picking.apk")
                                startActivity(openURL)

                            }
                        if (it.IsVersionCritical == 1) {
                            customDialog.setDescription(getString(R.string.updatecritical))
                        } else {
                            customDialog.setKoButton("Cancelar") {
                                customDialog.dismiss()
                                goToMain()
                            }
                        }
                        customDialog.show()

                    }

                }

            })
            logindevice.observe(viewLifecycleOwner, Observer {
                splash_progress.visibility = View.INVISIBLE
                if (it.isError) {
                    customDialog.setTitle("Error").setDescription(it.errorMessage)
                        .setOkButton("Cerrar") {
                            customDialog.dismiss()
                        }.show()
                } else {
                    splash_progress.visibility = View.VISIBLE
                    if (it.vIsAuthorized.equals("0")) {
                        splash_progress.visibility = View.INVISIBLE
                        // Log.i("VERDNATURA:",it.vMessage)

                        customDialog.setTitle("Error").setDescription(it.vMessage!!)
                            .setOkButton("Cerrar") {
                                customDialog.dismiss()
                                //  goToMain()
                            }.show()

                    } else {
                        //sergio: se añade el log
                        viewModel.worker_getId(
                            edittext_username.text.toString(),
                            edittext_password.text.toString(),
                            callFunction = "worker_getId"
                        )
                        deviceLog_add(
                            edittext_username.text.toString(),
                            edittext_password.text.toString(),
                            "warehouse",
                            getInfoVersionNameApp(),
                            getANDROIDID(),"deviceLog_add"
                        )

                        splash_progress.visibility = View.INVISIBLE
                        //saveUserFkPref(it)
                        if (switch_remember.isChecked) {
                            saveRemember(true)
                        } else {
                            saveRemember(false)
                        }

                        saveUserAccesPref(
                            edittext_username.text.toString(),
                            edittext_password.text.toString()
                        )


                        if (it.vIsAuthorized.equals("1") && it.vMessage.isNullOrEmpty()) {
                            //  Log.i("VERDNATURA", "Sin mensaje")
                            splash_progress.visibility = View.VISIBLE
                            loginSalix(
                                user = edittext_username.text.toString(),
                                password = edittext_password.text.toString(),
                                callFunction = "login de Salix"
                            )

                        }
                        if (it.vIsAuthorized.equals("1") && !it.vMessage.isNullOrEmpty()) {

                            customDialog.setTitle("Mensaje").setDescription(it.vMessage)
                                .setOkButton("Cerrar") {
                                    customDialog.dismiss()
                                    splash_progress.visibility = View.VISIBLE
                                    loginSalix(
                                        user = edittext_username.text.toString(),
                                        password = edittext_password.text.toString(),"login de Salix"
                                    )
                                }.show()

                        }

                    }

                }

            })



            workerId.observe(viewLifecycleOwner, Observer {
                splash_progress.visibility = View.INVISIBLE
                if (!it.isError) {
                    saveUserFkPref(it.Id.toString())
                }
                /*  customDialog.setTitle("Error").setDescription(it.errorMessage)
                      .setOkButton("Cerrar") {
                          customDialog.dismiss()
                      }.show()
              } else {
                  saveUserFkPref(it.Id.toString())
              }*/

            })

            loginitem.observe(viewLifecycleOwner, Observer {
                splash_progress.visibility = View.INVISIBLE
                if (it.isError) {
                    customDialog.setTitle("Error").setDescription(it.errorMessage)
                        .setOkButton("Cerrar") {
                            customDialog.dismiss()
                        }.show()
                } else {
                    splash_progress.visibility = View.VISIBLE
                    saveUserFkPref(it)
                    if (switch_remember.isChecked) {
                        saveRemember(true)
                    } else {
                        saveRemember(false)
                    }

                    saveUserAccesPref(
                        edittext_username.text.toString(),
                        edittext_password.text.toString()
                    )

                    loginSalix(
                        user = edittext_username.text.toString(),
                        password = edittext_password.text.toString(),
                        callFunction = "login de Salix"
                    )
                }

            })

            devicelogresponse.observe(viewLifecycleOwner, Observer {
                splash_progress.visibility = View.INVISIBLE
                if (it.isError) {
                    customDialog.setTitle("Error")
                        .setDescription(it.errorMessage)
                        .setOkButton(
                            "Aceptar"
                        ) {
                            customDialog.dismiss()
                            getVersion()
                        }.show()
                } else {

                }
            })

            loginsalixitem.observe(viewLifecycleOwner, Observer {
                splash_progress.visibility = View.INVISIBLE
                if (it.isError) {
                    saveTokenPref("")
                    customDialog.setTitle("Error")
                        .setDescription(it.errorMessage + ". Puedes continuar pero algunas funcionalidades no estarán disponibles.")
                        .setOkButton(
                            "Entendido"
                        ) {
                            customDialog.dismiss()
                            getVersion()
                        }.show()
                } else {
                    saveTokenPref(it.token)
                    getVersion()
                }
            })

            version.observe(viewLifecycleOwner, Observer {
                splash_progress.visibility = View.INVISIBLE
                if (it) {
                    /* customDialog.setTitle("Atención").setDescription("La aplicación se encuentra en fase de desarrollo. Algunas funcionalidades están desactivadas y se van a ir añadiendo de forma progresiva.").setOkButton("Entrar"){
                        goToMain()
                        customDialog.dismiss()
                    }.setKoButton("Cancelar"){
                        customDialog.dismiss()
                    }.show()*/
                    goToMain()

                } else {
                    customDialog.setTitle(getString(R.string.Actualizar))
                        .setDescription(getString(R.string.updatemng)).setOkButton(
                            getString(
                                R.string.Actualizar
                            )
                        ) {
                            val openURL = Intent(Intent.ACTION_VIEW)
                            openURL.data = Uri.parse("https://app.verdnatura.es/bin/vn-picking.apk")
                            startActivity(openURL)
                        }.setKoButton("Cancelar") {
                            customDialog.dismiss()
                            goToMain()
                        }.show()
                }
            })
        }
        super.observeViewModel()
    }

    private fun getInfoVersionNameApp(): String {
        val manager: PackageManager = requireContext().packageManager
        val info: PackageInfo = manager.getPackageInfo(requireContext().packageName, 0)
        return info.versionName
    }

    private fun saveTokenPref(token: String) {
        val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
        val editor = prefs.edit()
        editor.putString(TOKEN, token)
        editor.apply()
    }

    private fun saveUserFkPref(loginitem: LoginItemVO) {
        val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
        val editor = prefs.edit()
        editor.putString(USERFK, loginitem.id)
        editor.apply()
    }

    private fun saveUserFkPref(workerId: String) {
        val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
        val editor = prefs.edit()
        editor.putString(USERFK, workerId)
        editor.apply()
    }

    private fun saveUserAccesPref(user: String, password: String) {
        val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
        val editor = prefs.edit()
        editor.putString(USER, user)
        editor.putString(PASSWORD, password)
        editor.apply()
    }

    private fun saveRemember(remember: Boolean) {
        val prefs: SharedPreferences = requireActivity().getSharedPreferences(PREFS_USER, 0)
        val editor = prefs.edit()
        editor.putBoolean(RECORDAR, remember)
        editor.apply()
    }

    private fun goToMain() {
        val intent = Intent(activity, MainActivity::class.java)
        startActivity(intent)
        //splash_progress.visibility=View.GONE
        requireActivity().finish()
    }

    private fun getVersion() {
        splash_progress.visibility = View.VISIBLE
        viewModel.checkVersion(
            user = edittext_username.text.toString(),
            password = edittext_password.text.toString(),
            nameApp = "warehouse","getVersion"
        )

    }

    fun setDefaults(key: String?, value: String?, context: Context?) {
        val preferences: SharedPreferences = PreferenceManager.getDefaultSharedPreferences(context)
        val editor = preferences.edit()
        editor.putString(key, value)
        editor.commit()
    }

    fun getDefaults(key: String?, context: Context?): String? {
        val preferences = PreferenceManager.getDefaultSharedPreferences(context)
        return preferences.getString(key, null)
    }

    // sergio:creada restart en BaseFragment para AjustesFragment...
    fun restartapp() {
        val mStartActivity = Intent(context, LoginActivity::class.java)
        val mPendingIntentId = 123456
        val mPendingIntent = PendingIntent.getActivity(
            context,
            mPendingIntentId,
            mStartActivity,
            PendingIntent.FLAG_CANCEL_CURRENT
        )
        val mgr = requireContext().getSystemService(Context.ALARM_SERVICE) as AlarmManager
        mgr[AlarmManager.RTC, System.currentTimeMillis() + 100] = mPendingIntent
        System.exit(0)
    }

}
