package es.verdnatura.presentation.view.feature.paletizador.adapter


import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import es.verdnatura.databinding.ItemExpeditionstateRowBinding
import es.verdnatura.presentation.common.OnItemExpeditionStateRowClickListener
import es.verdnatura.presentation.view.feature.articulo.model.ItemCardRowVO
import es.verdnatura.presentation.view.feature.paletizador.model.ItemExpeditionStateRow

class ExpeditionStateAdapter  (
    private val items: List<ItemExpeditionStateRow>,
    private val OnItemExpeditionStateRowClickListener: OnItemExpeditionStateRowClickListener
): RecyclerView.Adapter<ExpeditionStateAdapter.ItemHolder> () {


    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ItemHolder {
        return ItemHolder(
            //ItemCardRowBinding.inflate(LayoutInflater.from(parent.context),parent,false)
            ItemExpeditionstateRowBinding.inflate(LayoutInflater.from(parent.context),parent,false)
        )
    }

    override fun getItemCount() =items.size

    override fun onBindViewHolder(holder: ItemHolder, position: Int) {
        holder.bind(items[position])
        if (items[position].isEditable){
            holder.binding.root.setOnClickListener {
                OnItemExpeditionStateRowClickListener.OnItemExpeditionStateRowClickListener(items[position])
            }
        }
    }


    class ItemHolder(
        val binding: ItemExpeditionstateRowBinding
    ) : RecyclerView.ViewHolder(binding.root){
        private val res = binding.root.context.resources
        fun bind(item: ItemExpeditionStateRow) {
            binding.apply {
                if (item.barcodes.isNotEmpty()){
                    item.value = ""
                    item.barcodes.forEach {
                        item.value = item.value + it.code + "\n"
                    }
                }
                this.item = item
              /*  if (item.isEditable){
                    itemImage.visibility = View.VISIBLE
                    itemRowLayout.setBackgroundColor(res.getColor(R.color.verdnatura_black_5))
                }else{
                    itemImage.visibility = View.INVISIBLE
                    itemRowLayout.setBackgroundColor(res.getColor(R.color.verdnatura_black_9))
                }*/

            }
        }
    }
}